diff -crN nakedmudv1.4/src/room.c nakedmudv1.5/src/room.c
*** nakedmudv1.4/src/room.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/room.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 126,164 ****
  
  STORAGE_SET *roomStore(ROOM_DATA *room) {
    STORAGE_SET *set = new_storage_set();
!   store_string(set, "name",    room->name,                  NULL);
!   store_string(set, "desc",    room->desc,                  NULL);
!   store_int   (set, "vnum",    room->vnum,                  NULL);
!   store_int   (set, "terrain", room->terrain,               NULL);
!   store_set   (set, "edescs",  edescSetStore(room->edescs), NULL);
  
    STORAGE_SET_LIST *exits = new_storage_list();
!   store_list(set, "exits", exits, NULL);
  
    // save all of the normal directions
    int i;
    for(i = 0; i < NUM_DIRS; i++) {
      if(room->exits[i]) {
        STORAGE_SET *exit = exitStore(room->exits[i]);
!       store_string(exit, "direction", dirGetName(i), NULL);
        storage_list_put(exits, exit);
      }
    }
  
    // and now the special directions
    int num_special_exits = 0;
!   char **special_exits = roomGetExitNames(room, &num_special_exits);
    for(i = 0; i < num_special_exits; i++) {
      STORAGE_SET *exit = exitStore(roomGetExitSpecial(room, special_exits[i]));
!     store_string(exit, "direction", special_exits[i], NULL);
      storage_list_put(exits, exit);
    }
    if(special_exits) free(special_exits);
  
!   // and store our reset data
!   store_list(set, "reset",     gen_store_list(room->reset, resetStore), NULL);
! 
!   store_set(set, "auxiliary",  auxiliaryDataStore(room->auxiliary_data), NULL);
    return set;
  }
  
--- 126,162 ----
  
  STORAGE_SET *roomStore(ROOM_DATA *room) {
    STORAGE_SET *set = new_storage_set();
!   store_string(set, "name",    room->name);
!   store_string(set, "desc",    room->desc);
!   store_int   (set, "vnum",    room->vnum);
!   store_int   (set, "terrain", room->terrain);
!   store_set   (set, "edescs",  edescSetStore(room->edescs));
  
    STORAGE_SET_LIST *exits = new_storage_list();
!   store_list(set, "exits", exits);
  
    // save all of the normal directions
    int i;
    for(i = 0; i < NUM_DIRS; i++) {
      if(room->exits[i]) {
        STORAGE_SET *exit = exitStore(room->exits[i]);
!       store_string(exit, "direction", dirGetName(i));
        storage_list_put(exits, exit);
      }
    }
  
    // and now the special directions
    int num_special_exits = 0;
!   const char **special_exits = roomGetExitNames(room, &num_special_exits);
    for(i = 0; i < num_special_exits; i++) {
      STORAGE_SET *exit = exitStore(roomGetExitSpecial(room, special_exits[i]));
!     store_string(exit, "direction", special_exits[i]);
      storage_list_put(exits, exit);
    }
    if(special_exits) free(special_exits);
  
!   store_list(set, "reset",     gen_store_list(room->reset, resetStore));
!   store_set(set, "auxiliary",  auxiliaryDataStore(room->auxiliary_data));
    return set;
  }
  
***************
*** 203,209 ****
  
  void roomCopyTo(ROOM_DATA *from, ROOM_DATA *to) {
    int i, num_spec_exits;
!   char **spec_exits;
  
    // we just want to copy data ABOUT the room, and not stuff
    // contained in the particular instance (e.g. players, contents)
--- 201,207 ----
  
  void roomCopyTo(ROOM_DATA *from, ROOM_DATA *to) {
    int i, num_spec_exits;
!   const char **spec_exits;
  
    // we just want to copy data ABOUT the room, and not stuff
    // contained in the particular instance (e.g. players, contents)
***************
*** 224,233 ****
  
    // free the special exits of the <to> room
    spec_exits = roomGetExitNames(to, &num_spec_exits);
!   for(i = 0; i < num_spec_exits; i++) {
      roomSetExitSpecial(to, spec_exits[i], NULL);
-     free(spec_exits[i]);
-   }
    free(spec_exits);
    deleteHashtable(to->special_exits);
    to->special_exits = newHashtable(SPECIAL_EXIT_BUCKETS);
--- 222,229 ----
  
    // free the special exits of the <to> room
    spec_exits = roomGetExitNames(to, &num_spec_exits);
!   for(i = 0; i < num_spec_exits; i++)
      roomSetExitSpecial(to, spec_exits[i], NULL);
    free(spec_exits);
    deleteHashtable(to->special_exits);
    to->special_exits = newHashtable(SPECIAL_EXIT_BUCKETS);
***************
*** 235,245 ****
  
    // set the special exits of the <to> room
    spec_exits = roomGetExitNames(from, &num_spec_exits);
!   for(i = 0; i < num_spec_exits; i++) {
      roomSetExitSpecial(to, spec_exits[i], 
  		       exitCopy(roomGetExitSpecial(from, spec_exits[i])));
-     free(spec_exits[i]);
-   }
    free(spec_exits);
  
    
--- 231,239 ----
  
    // set the special exits of the <to> room
    spec_exits = roomGetExitNames(from, &num_spec_exits);
!   for(i = 0; i < num_spec_exits; i++)
      roomSetExitSpecial(to, spec_exits[i], 
  		       exitCopy(roomGetExitSpecial(from, spec_exits[i])));
    free(spec_exits);
  
    
***************
*** 284,290 ****
  #ifdef MODULE_SCRIPTS
    try_scripts(SCRIPT_TYPE_INIT,
  	      room, SCRIPTOR_ROOM,
! 	      NULL, NULL, room, NULL, NULL, NULL, 0);
  #endif
  }
  
--- 278,284 ----
  #ifdef MODULE_SCRIPTS
    try_scripts(SCRIPT_TYPE_INIT,
  	      room, SCRIPTOR_ROOM,
! 	      NULL, NULL, room, NULL, NULL, 0);
  #endif
  }
  
***************
*** 365,381 ****
    return hashGet(room->special_exits, dir);
  };
  
! char      **roomGetExitNames   (const ROOM_DATA *room, int *num) {
    int i;
  
    *num = hashSize(room->special_exits);
!   char **names = malloc(sizeof(char *) * *num);
    HASH_ITERATOR *hash_i = newHashIterator(room->special_exits);
  
    for(i = 0; i < *num; i++, hashIteratorNext(hash_i))
!     names[i] = strdup(hashIteratorCurrentKey(hash_i));
! 
    deleteHashIterator(hash_i);
    return names;
  };
  
--- 359,375 ----
    return hashGet(room->special_exits, dir);
  };
  
! const char      **roomGetExitNames   (const ROOM_DATA *room, int *num) {
    int i;
  
    *num = hashSize(room->special_exits);
!   const char **names = malloc(sizeof(char *) * *num);
    HASH_ITERATOR *hash_i = newHashIterator(room->special_exits);
  
    for(i = 0; i < *num; i++, hashIteratorNext(hash_i))
!     names[i] = hashIteratorCurrentKey(hash_i);
    deleteHashIterator(hash_i);
+ 
    return names;
  };
  
***************
*** 503,687 ****
  //*****************************************************************************
  struct terrain_data {
    char   *name;
-   char   *default_rname;
-   char   *default_rdesc;
-   char   *map_symbol;
-   double  move_difficulty;
-   double  visibility;
  };
  
  const struct terrain_data terrain_types[NUM_TERRAINS] = {
!   { "Inside",             
!     "Inside", 
!     "You are not outside. This desc should never be seen.\r\n",
!     "{w.",      1.0,    1.0 },
! 
!   { "City",               
!     "In the City", 
!     "You are in a city. This desc should never be seen.\r\n",
!     "{g.",      1.0,    0.6 },
! 
!   { "Road", 
!     "On a Road", 
!     "The road beneath your feet is quite well made, and looks like it is "
!     "taken care of on a regular basis. The foundation is a thick mortar, and "
!     "there are virtually no cracks in it. You see the occasionally band of "
!     "travellers pass you by, or a merchant riding a wagon hitched up to a "
!     "horse heading in the opposite direction as you.\r\n",
!     "{w.",      1.0,    1.0 },  
! 
!   { "Bridge",             
!     "On a Bridge", 
!     "The bridge appears to be quite sturdy; its foundation is a solid stone, "
!     "and it looks like it was crafted by master builders. To either side of "
!     "the bridge, you see a road continuing on for quite some ways.\r\n",
!     "{g#",      1.0,    1.0 },
! 
!   { "Shallow Water",       
!     "In Shallow Water", 
!     "The water is refreshingly cool on your skin, and it is shallow enough "
!     "that you are able to wade in it without relative ease. Occasionally, you "
!     "will see a glint of color under the water, which is probably a fish "
!     "swimming by you.\r\n",
!     "{B~",      0.5,    1.0 },
! 
!   { "Deep Water",    
!     "In Deep Waters", 
!     "The water here is much too deep to wade into. Ripples undulate around "
!     "you on the water's surface, spreading out in a beautiful rippling "
!     "pattern. Occasionally, you see a bird dive down into the water and "
!     "snatch up a fish.\r\n",
!     "{bw",      0.2,    1.0 },
! 
!   { "Ocean",
!     "On The Ocean",
!     "Water, water everywhere! On all sides, you are surrounded by an endless "
!     "view of water. At least the water is calm; occasionally, small waves "
!     "rock you back and forth, but other than that there is very little "
!     "disturbance of the water. Occasionally, you see a group of sea birds "
!     "flying overhead, or a blurry figure swimming slightly below the surface "
!     "of the water.\r\n",
!     "{bo",      0.1,    0.8 },
! 
!   { "Underwater",         
!     "Underwater", 
!     "Your vision is somewhat obscured by the water around you, but you manage "
!     "to make out shapes of various water creatures around you; hoards of "
!     "fish, sponges, and seaweed. Many more exotic creatures swim about as "
!     "well, but you are hard pressed to name any of them.\r\n",
!     "{bu",      0.1,    0.5 },
! 
!   { "Field",              
!     "In a Field", 
!     "You are in a field. Occasionally, you hear birds chirping, and "
!     "you see the occasional one fly overhead. The wilderness is quite "
!     "peaceful.\r\n",
!     "{g\"",    1.0,     1.0 },
! 
!   { "Plains",             
!     "On The Plains", 
!     "You are on the open plains. Occasionally, You see the occasional hawk "
!     "fly overhead, and you spot many small rodents as you walk. The plains "
!     "are quite flat, and you can literally see for miles.\r\n",
!     "#Yp",    1.0,      1.0 },
! 
!   { "Meadow",
!     "In A Meadow",
!     "The meadow is a sea of tall, dried yellowish grass. There is a slight "
!     "breeze, and the grass is bent in the direction the wind is blowing. You "
!     "see the occasional grasshopper leap past you as you make your way "
!     "through the meadow. Birds circle in the air above - they look like tiny "
!     "specks from where you are.\r\n",
!     "#Ym",    1.0,      1.0 },
! 
!   { "Forest",             
!     "In a Wooded Forest",
!     "Trees surround you on all sides. Poplar, fur, birch - all kinds. "
!     "The trees are not so thick that you have a hard time seeing, but "
!     "your vision is definitely impeded slightly by the trees.\r\n",
!     "{Gf",    0.8,      0.7 },
! 
!   { "Deep Forest",        
!     "In a Deep Forest", 
!     "Trees surround you on all sides. Poplar, fur, birch - all kinds. "
!     "The trees get quite thick here, and it becomes rather hard to see "
!     "anything that is not in your immediate vicinity.\r\n",
!     "{gD",    0.5,      0.4 },
! 
!   { "Hills",              
!     "On Rolling Hills", 
!     "Small hills cover the ground here, in wavy patterns. The ground is "
!     "fairly nondescript - dirt and grass. Occasionally, you spot a hole "
!     "in the ground. You would guess it to be the home of some small rodent. "
!     "\r\n",
!     "{yh",    0.7,      0.8 },
! 
!   { "High Hills",
!     "Amidst High Hills",
!     "The hills here are steep and plentiful. They are scattered across the "
!     "terrain like waves in the ocean. The ground here is rather hard, and "
!     "very rough. You spot the occasional patch of grass, but for the most "
!     "part, the ground is simply dirt. You spot holes in the ground every now "
!     "and then. Occasionally, a small rodent pokes its head in one, and then "
!     "scurries back into its shelter.\r\n",
!     "{yH",   0.4,        0.5 },
! 
!   { "Mountains",         
!     "In the Mountains", 
!     "The mountain is quite rocky, and here and there you see patches of snow "
!     "on the ground. Are visible here and there, but you notice they start to "
!     "thin out as the mountain rises up.\r\n",
!     "{w^",   0.1,        0.1 },
! 
!   { "Swamp",              
!     "In a Swamp", 
!     "The odor of the swamp is reminiscent of mold and rotting materials. "
!     "The ground is quite moist, and occasionally large bubbles float up to "
!     "the surface of it and pop, letting out rather noxious fumes. The air "
!     "is also quite damp, and very warm. Occasionally, you will hear the cry "
!     "of a bird off in the distance, or what sounds like twigs snapping.\r\n",
!     "#rs",   0.3,        0.5 },
! 
!   { "Deep Swamp",
!     "Deep in the Swamp",
!     "The air here is humid, and a very musky smell lingers about. The ground "
!     "here is quite moist - dirty, murky water rises up to your ankles. Your "
!     "surroundings are ominously quiet, except for the occasional shrill cry "
!     "of a bird off in the distance. Rotten pieces of wood float in the water "
!     "beneath your feet. Some drift as if they are a live. But, of course, "
!     "driftwood doesn't live. Or maybe that's not driftwood.\r\n",
!     "#rS",   0.1,        0.3 },
! 
!   { "Sand",               
!     "On Sand", 
!     "The sand is a bright golden yellow, and have a very fine grain. You "
!     "see the occasional rock sticking out of the sand at an odd angle, and "
!     "a small crab here or there, scurrying along.\r\n",
!     "{y\"",  0.8,        1.0 },
! 
!   { "Desert",
!     "In A Desert",
!     "Sand streches out around you for miles in every direction. The air is "
!     "unbearably hot, and very dry. Your lips are getting more and more "
!     "chapped with every passing moment. The sun beams down on you with its "
!     "relentless gaze, burning your skin and making you slightly lightheaded. "
!     "It is a wonder even the most hearty of animals can live out here.\r\n",
!     "{yD",   0.7,        1.0 },
! 
!   { "Ice",
!     "On Ice",
!     "Ice needs a description.\r\n",
!     "{CI",   0.5,        0.7 },
! 
!   { "Glacier",
!     "Amidst Glaciers",
!     "Glaciers need a description.\r\n",
!     "{cG",   0.3,        0.3 },
! 
!   { "Cavern",
!     "Within a Cavern",
!     "Caverns need a description.\r\n",
!     " ",   1.0,        0.7 }
  };
  
  
--- 497,529 ----
  //*****************************************************************************
  struct terrain_data {
    char   *name;
  };
  
  const struct terrain_data terrain_types[NUM_TERRAINS] = {
!   { "Inside"        },
!   { "City"          },
!   { "Road"          },
!   { "Alley"         },
!   { "Bridge"        },
!   { "Shallow Water" },
!   { "Deep Water"    },
!   { "Ocean"         },
!   { "Underwater"    },
!   { "Field"         },
!   { "Plains"        },
!   { "Meadow"        },
!   { "Forest"        },
!   { "Deep Forest"   },
!   { "Hills"         },
!   { "High Hills"    },
!   { "Mountains"     },
!   { "Swamp"         },
!   { "Deep Swamp"    },
!   { "Sand"          },
!   { "Desert"        }, 
!   { "Ice"           },
!   { "Glacier"       },
!   { "Cavern"        },
  };
  
  
***************
*** 689,714 ****
    return terrain_types[terrain].name;
  }
  
- const char *terrainGetDefaultRname(int terrain) {
-   return terrain_types[terrain].default_rname;
- }
- 
- const char *terrainGetDefaultRdesc(int terrain) {
-   return terrain_types[terrain].default_rdesc;
- }
- 
- const char *terrainGetMapSymbol(int terrain) {
-   return terrain_types[terrain].map_symbol;
- }
- 
- double      terrainGetVisibility(int terrain) {
-   return terrain_types[terrain].visibility;
- }
- 
- double      terrainGetMoveDifficulty(int terrain) {
-   return terrain_types[terrain].move_difficulty;
- }
- 
  int terrainGetNum(const char *terrain) {
    int i;
    for(i = 0; i < NUM_TERRAINS; i++)
--- 531,536 ----
***************
*** 716,719 ****
        return i;
    return TERRAIN_NONE;
  }
- 
--- 538,540 ----
diff -crN nakedmudv1.4/src/room.h nakedmudv1.5/src/room.h
*** nakedmudv1.4/src/room.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/room.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 32,58 ****
  #define TERRAIN_INDOORS         0	
  #define TERRAIN_CITY            1	
  #define TERRAIN_ROAD            2
! #define TERRAIN_BRIDGE          3 
! #define TERRAIN_SHALLOW_WATER   4	
! #define TERRAIN_DEEP_WATER      5	
! #define TERRAIN_OCEAN           6
! #define TERRAIN_UNDERWATER	7	
! #define TERRAIN_FIELD           8	
! #define TERRAIN_PLAINS          9 
! #define TERRAIN_MEADOW         10
! #define TERRAIN_FOREST         11
! #define TERRAIN_DEEP_FOREST    12 
! #define TERRAIN_HILLS          13
! #define TERRAIN_HIGH_HILLS     14
! #define TERRAIN_MOUNTAIN       15
! #define TERRAIN_SWAMP          16 
! #define TERRAIN_DEEP_SWAMP     17
! #define TERRAIN_SAND           18 
! #define TERRAIN_DESERT         19
! #define TERRAIN_ICE            20
! #define TERRAIN_GLACIER        21
! #define TERRAIN_CAVERN         22
! #define NUM_TERRAINS           23
  
  
  //
--- 32,59 ----
  #define TERRAIN_INDOORS         0	
  #define TERRAIN_CITY            1	
  #define TERRAIN_ROAD            2
! #define TERRAIN_ALLEY           3
! #define TERRAIN_BRIDGE          4 
! #define TERRAIN_SHALLOW_WATER   5	
! #define TERRAIN_DEEP_WATER      6	
! #define TERRAIN_OCEAN           7
! #define TERRAIN_UNDERWATER	8	
! #define TERRAIN_FIELD           9	
! #define TERRAIN_PLAINS         10 
! #define TERRAIN_MEADOW         11
! #define TERRAIN_FOREST         12
! #define TERRAIN_DEEP_FOREST    13 
! #define TERRAIN_HILLS          14
! #define TERRAIN_HIGH_HILLS     15
! #define TERRAIN_MOUNTAIN       16
! #define TERRAIN_SWAMP          17 
! #define TERRAIN_DEEP_SWAMP     18
! #define TERRAIN_SAND           19 
! #define TERRAIN_DESERT         20
! #define TERRAIN_ICE            21
! #define TERRAIN_GLACIER        22
! #define TERRAIN_CAVERN         23
! #define NUM_TERRAINS           24
  
  
  //
***************
*** 122,128 ****
  
  EXIT_DATA  *roomGetExit         (const ROOM_DATA *room, int dir);
  EXIT_DATA  *roomGetExitSpecial  (const ROOM_DATA *room, const char *dir);
! char      **roomGetExitNames    (const ROOM_DATA *room, int *num);
  EDESC_SET  *roomGetEdescs       (const ROOM_DATA *room);
  const char *roomGetEdesc        (const ROOM_DATA *room, const char *keyword);
  void       *roomGetAuxiliaryData(const ROOM_DATA *room, const char *name);
--- 123,129 ----
  
  EXIT_DATA  *roomGetExit         (const ROOM_DATA *room, int dir);
  EXIT_DATA  *roomGetExitSpecial  (const ROOM_DATA *room, const char *dir);
! const char **roomGetExitNames   (const ROOM_DATA *room, int *num);
  EDESC_SET  *roomGetEdescs       (const ROOM_DATA *room);
  const char *roomGetEdesc        (const ROOM_DATA *room, const char *keyword);
  void       *roomGetAuxiliaryData(const ROOM_DATA *room, const char *name);
***************
*** 165,177 ****
  //
  //*****************************************************************************
  const char *terrainGetName(int terrain);
! const char *terrainGetDefaultRname(int terrain);
! const char *terrainGetDefaultRdesc(int terrain);
! const char *terrainGetMapSymbol(int terrain);
! double      terrainGetVisibility(int terrain); // [0, 1]
! double      terrainGetExhaustion(int terrain); // [0, 1]
! 
! int terrainGetNum(const char *terrain);
  
  
  #endif // __ROOM_H
--- 166,172 ----
  //
  //*****************************************************************************
  const char *terrainGetName(int terrain);
! int  terrainGetNum(const char *terrain);
  
  
  #endif // __ROOM_H
diff -crN nakedmudv1.4/src/room_reset.c nakedmudv1.5/src/room_reset.c
*** nakedmudv1.4/src/room_reset.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/room_reset.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 27,33 ****
    int        type; // what kind of reset are we?
    int       times; // how many times should it be executed?
    int      chance; // what is our chance of success?
!   int         max; // what is the max number of us that ca nbe in the game?
    int    room_max; // what is the max number of us that can be in the room?
    char       *arg; // what is our reset arg (e.g. mob vnum, direction name)
    LIST        *in; // what resets do we put into ourself?
--- 27,33 ----
    int        type; // what kind of reset are we?
    int       times; // how many times should it be executed?
    int      chance; // what is our chance of success?
!   int         max; // what is the max number of us that can be in the game?
    int    room_max; // what is the max number of us that can be in the room?
    char       *arg; // what is our reset arg (e.g. mob vnum, direction name)
    LIST        *in; // what resets do we put into ourself?
***************
*** 108,122 ****
  
  STORAGE_SET   *resetStore       (RESET_DATA *reset) {
    STORAGE_SET *set = new_storage_set();
!   store_int   (set, "type",     reset->type,     NULL);
!   store_int   (set, "times",    reset->times,    NULL);
!   store_int   (set, "chance",   reset->chance,   NULL);
!   store_int   (set, "max",      reset->max,      NULL);
!   store_int   (set, "room_max", reset->room_max, NULL);
!   store_string(set, "arg",      reset->arg,      NULL);
!   store_list  (set, "in",       gen_store_list(reset->in,   resetStore), NULL);
!   store_list  (set, "on",       gen_store_list(reset->on,   resetStore), NULL);
!   store_list  (set, "then",     gen_store_list(reset->then, resetStore), NULL);
    return set;
  }
  
--- 108,122 ----
  
  STORAGE_SET   *resetStore       (RESET_DATA *reset) {
    STORAGE_SET *set = new_storage_set();
!   store_int   (set, "type",     reset->type);
!   store_int   (set, "times",    reset->times);
!   store_int   (set, "chance",   reset->chance);
!   store_int   (set, "max",      reset->max);
!   store_int   (set, "room_max", reset->room_max);
!   store_string(set, "arg",      reset->arg);
!   store_list  (set, "in",       gen_store_list(reset->in,   resetStore));
!   store_list  (set, "on",       gen_store_list(reset->on,   resetStore));
!   store_list  (set, "then",     gen_store_list(reset->then, resetStore));
    return set;
  }
  
***************
*** 568,581 ****
  bool resetRun(RESET_DATA *reset, void *initiator, int initiator_type) {
    //
    // possible problem: how do we know what to return if we're
!   // running it multiple times? 
    //
    bool ret_val = FALSE;
  
    // go through for however many times we need to
    int i;
    for(i = 0; i < resetGetTimes(reset); i++) {
!     // check our chance
      if(rand_number(1, 100) > resetGetChance(reset))
        continue;
      switch(resetGetType(reset)) {
--- 568,581 ----
  bool resetRun(RESET_DATA *reset, void *initiator, int initiator_type) {
    //
    // possible problem: how do we know what to return if we're
!   // running the reset data multiple times? 
    //
    bool ret_val = FALSE;
  
    // go through for however many times we need to
    int i;
    for(i = 0; i < resetGetTimes(reset); i++) {
!     // If we don't make our reset chance, continue onto the next check
      if(rand_number(1, 100) > resetGetChance(reset))
        continue;
      switch(resetGetType(reset)) {
diff -crN nakedmudv1.4/src/save.c nakedmudv1.5/src/save.c
*** nakedmudv1.4/src/save.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/save.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 79,86 ****
  void save_objfile(CHAR_DATA *ch) {
    STORAGE_SET *set = new_storage_set();
    // write all of the inventory
!   store_list(set, "inventory", gen_store_list(charGetInventory(ch), objStore),
! 	     NULL);
    
    // for equipped items, it's not so easy - we also have to record
    // whereabouts on the body the equipment was worn on
--- 79,85 ----
  void save_objfile(CHAR_DATA *ch) {
    STORAGE_SET *set = new_storage_set();
    // write all of the inventory
!   store_list(set, "inventory", gen_store_list(charGetInventory(ch), objStore));
    
    // for equipped items, it's not so easy - we also have to record
    // whereabouts on the body the equipment was worn on
***************
*** 89,100 ****
    OBJ_DATA *obj = NULL;
    while((obj = listPop(eq_list)) != NULL) {
      STORAGE_SET *eq_set = objStore(obj);
!     store_string(set, "equipped", bodyEquippedWhere(charGetBody(ch), obj),NULL);
      storage_list_put(list, eq_set);
    }
    deleteList(eq_list);
  
!   store_list(set, "equipment", list, NULL);
    storage_write(set, get_char_filename(charGetName(ch), FILETYPE_OFILE));
    storage_close(set);
  }
--- 88,99 ----
    OBJ_DATA *obj = NULL;
    while((obj = listPop(eq_list)) != NULL) {
      STORAGE_SET *eq_set = objStore(obj);
!     store_string(set, "equipped", bodyEquippedWhere(charGetBody(ch), obj));
      storage_list_put(list, eq_set);
    }
    deleteList(eq_list);
  
!   store_list(set, "equipment", list);
    storage_write(set, get_char_filename(charGetName(ch), FILETYPE_OFILE));
    storage_close(set);
  }
***************
*** 168,176 ****
   */
  void save_profile(CHAR_DATA *ch) {
    STORAGE_SET *set = new_storage_set();
!   store_string(set, "name",     charGetName(ch),     NULL);
!   store_string(set, "password", charGetPassword(ch), NULL);
!   store_int   (set, "uid",      charGetUID(ch),      NULL);
    storage_write(set, get_char_filename(charGetName(ch), FILETYPE_PROFILE));
    storage_close(set);
  }
--- 167,175 ----
   */
  void save_profile(CHAR_DATA *ch) {
    STORAGE_SET *set = new_storage_set();
!   store_string(set, "name",     charGetName(ch));
!   store_string(set, "password", charGetPassword(ch));
!   store_int   (set, "uid",      charGetUID(ch));
    storage_write(set, get_char_filename(charGetName(ch), FILETYPE_PROFILE));
    storage_close(set);
  }
diff -crN nakedmudv1.4/src/scripts/pychar.c nakedmudv1.5/src/scripts/pychar.c
*** nakedmudv1.4/src/scripts/pychar.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/scripts/pychar.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 261,267 ****
  static PyObject *
  PyChar_getrace(PyChar *self, void *closure) {
    CHAR_DATA *ch = propertyTableGet(mob_table, self->uid);
!   if(ch != NULL) return Py_BuildValue("s", raceGetName(charGetRace(ch)));
    else           return NULL;
  }
  
--- 261,267 ----
  static PyObject *
  PyChar_getrace(PyChar *self, void *closure) {
    CHAR_DATA *ch = propertyTableGet(mob_table, self->uid);
!   if(ch != NULL) return Py_BuildValue("s", charGetRace(ch));
    else           return NULL;
  }
  
***************
*** 434,441 ****
      return -1;
    }
  
!   int race = raceGetNum(PyString_AsString(value));
!   if(race == RACE_NONE) {
      char buf[SMALL_BUFFER];
      sprintf(buf, "%s is an invalid race type", PyString_AsString(value));
      PyErr_Format(PyExc_TypeError, buf);
--- 434,441 ----
      return -1;
    }
  
!   const char *race = PyString_AsString(value);
!   if(!isRace(race)) {
      char buf[SMALL_BUFFER];
      sprintf(buf, "%s is an invalid race type", PyString_AsString(value));
      PyErr_Format(PyExc_TypeError, buf);
***************
*** 814,820 ****
    // check for initialization scripts
    try_scripts(SCRIPT_TYPE_INIT,
  	      mob, SCRIPTOR_CHAR,
! 	      mob, NULL, room, NULL, NULL, NULL, 0);
  
    // create a python object for the new char, and return it
    PyChar *py_mob = (PyChar *)newPyChar(mob);
--- 814,820 ----
    // check for initialization scripts
    try_scripts(SCRIPT_TYPE_INIT,
  	      mob, SCRIPTOR_CHAR,
! 	      mob, NULL, room, NULL, NULL, 0);
  
    // create a python object for the new char, and return it
    PyChar *py_mob = (PyChar *)newPyChar(mob);
diff -crN nakedmudv1.4/src/scripts/pyobj.c nakedmudv1.5/src/scripts/pyobj.c
*** nakedmudv1.4/src/scripts/pyobj.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/scripts/pyobj.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 399,405 ****
    // check for initialization scripts
    try_scripts(SCRIPT_TYPE_INIT,
  	      obj, SCRIPTOR_OBJ,
! 	      ch, cont, room, NULL, NULL, NULL, 0);
  
    // create a python object for the new obj, and return it
    PyObj *py_obj = (PyObj *)newPyObj(obj);
--- 399,405 ----
    // check for initialization scripts
    try_scripts(SCRIPT_TYPE_INIT,
  	      obj, SCRIPTOR_OBJ,
! 	      ch, cont, room, NULL, NULL, 0);
  
    // create a python object for the new obj, and return it
    PyObj *py_obj = (PyObj *)newPyObj(obj);
